﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Info2Praktikum;

namespace _2011_05_04_Praktikum
{
    /// <summary>
    /// Interaktionslogik für BrightnessAdjuster.xaml
    /// </summary>
    public partial class BrightnessAdjusterWindow : Window
    {
        BrightnessAdjuster brightnessAdjuster;

        public BrightnessAdjusterWindow(BrightnessAdjuster brightnessAdjuster)
        {
            this.brightnessAdjuster = brightnessAdjuster;
            InitializeComponent();
            sliderBrightness.Value = brightnessAdjuster.BrightnessFactor;
        }

        private void sliderBrightness_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            brightnessAdjuster.BrightnessFactor = sliderBrightness.Value;
        }
    }

    public class BrightnessAdjuster : Filter
    {
        double brightnessFactor = 1.0;
        BrightnessAdjusterWindow window;
        MainWindow mainWindow;

        public BrightnessAdjuster(MainWindow mainWindow, double brightnessFactor)
        {
            this.mainWindow = mainWindow; // Wir merken uns das Hauptfenster, um die Listbox aktualisieren zu können.
            this.brightnessFactor = brightnessFactor;
        }

        public double BrightnessFactor
        {
            get
            {
                return brightnessFactor;
            }
            set
            {
                brightnessFactor = value;
                mainWindow.RefreshItems();
            }
        }

        public override Bitmap Execute(Bitmap input)
        {
            Bitmap result = new Bitmap(input.Width, input.Height);
            for (int y = 0; y < result.Height; y++)
            {
                for (int x = 0; x < result.Width; x++)
                {
                    result.SetRed(x, y, (int)Math.Min(255, brightnessFactor * input.GetRed(x, y)));
                    result.SetGreen(x, y, (int)Math.Min(255, brightnessFactor * input.GetGreen(x, y)));
                    result.SetBlue(x, y, (int)Math.Min(255, brightnessFactor * input.GetBlue(x, y)));
                }
            }
            return result;
        }

        public override string ToString()
        {
            if (brightnessFactor >= 1.0)
            {
                return "Aufhellen um " + (100.0 * (brightnessFactor - 1.0)).ToString("F1") + " Prozent";
            }
            else
            {
                return "Abdunkeln um " + (100.0 * (1.0 - brightnessFactor)).ToString("F1") + " Prozent";
            }
        }

        public override void ShowSettings()
        {
            if (window == null || !window.IsLoaded)
            {
                window = new BrightnessAdjusterWindow(this);
                window.Show();
            }
        }

        public override void CloseSettings()
        {
            if (window != null)
            {
                window.Close();
            }
        }
    }
}
